[DEFAULT]
#admin_token = <None>
#public_endpoint = <None>
#admin_endpoint = <None>
#max_project_tree_depth = 5
#max_param_size = 64
#max_token_size = 255
#list_limit = <None>
#strict_password_check = false

secure_proxy_ssl_header = HTTP_X_FORWARDED_PROTO
#insecure_debug = false
#default_publisher_id = <None>
#notification_format = cadf
#notification_opt_out = identity.authenticate.success
#notification_opt_out = identity.authenticate.pending
#notification_opt_out = identity.authenticate.failed

#debug = false
#log_config_append = <None>
#log_date_format = %Y-%m-%d %H:%M:%S
#log_file = <None>
#log_dir = <None>
#watch_log_file = false
#use_syslog = false
#use_journal = false
#syslog_log_facility = LOG_USER
#use_json = false
#use_stderr = false
#use_eventlog = false
#log_rotate_interval = 1
#log_rotate_interval_type = days
#max_logfile_count = 30
#max_logfile_size_mb = 200
#log_rotation_type = none
#logging_context_format_string = %(asctime)s.%(msecs)03d %(process)d %(levelname)s %(name)s [%(request_id)s %(user_identity)s] %(instance)s%(message)s
#logging_default_format_string = %(asctime)s.%(msecs)03d %(process)d %(levelname)s %(name)s [-] %(instance)s%(message)s
#logging_debug_format_suffix = %(funcName)s %(pathname)s:%(lineno)d
#logging_exception_prefix = %(asctime)s.%(msecs)03d %(process)d ERROR %(name)s %(instance)s
#logging_user_identity_format = %(user)s %(tenant)s %(domain)s %(user_domain)s %(project_domain)s
#default_log_levels = amqp=WARN,amqplib=WARN,boto=WARN,qpid=WARN,sqlalchemy=WARN,suds=INFO,oslo.messaging=INFO,oslo_messaging=INFO,iso8601=WARN,requests.packages.urllib3.connectionpool=WARN,urllib3.connectionpool=WARN,websocket=WARN,requests.packages.urllib3.util.retry=WARN,urllib3.util.retry=WARN,keystonemiddleware=WARN,routes.middleware=WARN,stevedore=WARN,taskflow=WARN,keystoneauth=WARN,oslo.cache=INFO,oslo_policy=INFO,dogpile.core.dogpile=INFO
#publish_errors = false
#instance_format = "[instance: %(uuid)s] "
#instance_uuid_format = "[instance: %(uuid)s] "
#rate_limit_interval = 0
#rate_limit_burst = 0
#rate_limit_except_level = CRITICAL
#fatal_deprecations = false
#rpc_conn_pool_size = 30
#conn_pool_min_size = 2
#conn_pool_ttl = 1200
#executor_thread_pool_size = 64
#rpc_response_timeout = 60

transport_url = {{ rabbit_transport_url }}
#control_exchange = keystone

[access_rules_config]
#driver = json
#caching = true
#cache_time = <None>
#rules_file = /etc/keystone/access_rules.json
#permissive = false

[application_credential]
#driver = sql
#caching = true
#cache_time = <None>
#user_limit = -1

[assignment]
#driver = sql
#prohibited_implied_role = admin

[auth]
methods = {{ openstack_keystone_auth_methods }}
#password = keystone.auth.plugins.password.Password
#token = keystone.auth.plugins.token.Token
#external = <None>
#oauth1 = <None>
#mapped = keystone.auth.plugins.mapped.Mapped
#application_credential = <None>
#openid = keystone.auth.plugins.mapped.Mapped

[cache]
config_prefix = cache.oslo
expiration_time = 600
backend = dogpile.cache.memcached
backend_argument = url:127.0.0.1:11211
#proxies =

enabled = true
#debug_cache_backend = false

memcache_servers = {{ openstack_memcached_servers }}
#memcache_dead_retry = 300
#memcache_socket_timeout = 3.0

memcache_pool_maxsize = 50
#memcache_pool_unused_timeout = 60
#memcache_pool_connection_get_timeout = 10

[catalog]
#template_file = default_catalog.templates
#driver = sql
#caching = true
#cache_time = <None>
#list_limit = <None>

[cors]
#allowed_origin = <None>
#allow_credentials = true
#expose_headers = X-Auth-Token,X-Openstack-Request-Id,X-Subject-Token,Openstack-Auth-Receipt
#max_age = 3600
#allow_methods = GET,PUT,POST,DELETE,PATCH
#allow_headers = X-Auth-Token,X-Openstack-Request-Id,X-Subject-Token,X-Project-Id,X-Project-Name,X-Project-Domain-Id,X-Project-Domain-Name,X-Domain-Id,X-Domain-Name,Openstack-Auth-Receipt

[credential]
#driver = sql
#provider = fernet
#key_repository = /etc/keystone/credential-keys/

[database]
connection = "mysql+pymysql://keystone:{{ openstack_keystone_db_password }}@{{ keystone_database_host }}/keystone"
#sqlite_synchronous = true
#backend = sqlalchemy
#connection = <None>
#slave_connection = <None>
#mysql_sql_mode = TRADITIONAL
#mysql_enable_ndb = false
#connection_recycle_time = 3600
#min_pool_size = 1
#max_pool_size = 5
#max_retries = 10
#retry_interval = 10
#max_overflow = 50
#connection_debug = 0
#connection_trace = false
#pool_timeout = <None>
#use_db_reconnect = false
#db_retry_interval = 1
#db_inc_retry_interval = true
#db_max_retry_interval = 10
#db_max_retries = 20
#connection_parameters =

[domain_config]
#driver = sql
#caching = true
#cache_time = 300

[endpoint_filter]
#driver = sql
#return_all_endpoints_if_no_filter = true

[endpoint_policy]
#driver = sql

[eventlet_server]
#public_bind_host = 0.0.0.0
#public_port = 5000
#admin_bind_host = 0.0.0.0
#admin_port = 35357

[federation]
#driver = sql
#assertion_prefix =
#remote_id_attribute = <None>

federated_domain_name = Default
trusted_dashboard = {{ openstack_keystone_trusted_dashboard }}
{% if openstack_keystone_trusted_dashboard2 is defined %}
trusted_dashboard = {{ openstack_keystone_trusted_dashboard2 }}
{% else %}
#trusted_dashboard =
{% endif %}
sso_callback_template = /etc/keystone/sso_callback_template.html
caching = true

[fernet_receipts]
key_repository = /etc/keystone/fernet-keys/
max_active_keys = 3

[fernet_tokens]
key_repository = /etc/keystone/fernet-keys/
max_active_keys = 3

[healthcheck]
#path = /healthcheck
#detailed = false
#backends =
#disable_by_file_path = <None>
#disable_by_file_paths =

[identity]
#default_domain_id = default
#domain_specific_drivers_enabled = false
#domain_configurations_from_database = false
#domain_config_dir = /etc/keystone/domains
#driver = sql
#caching = true
#cache_time = 600
#max_password_length = 4096
#list_limit = <None>
#password_hash_algorithm = bcrypt
#password_hash_rounds = <None>
#scrypt_block_size = <None>
#scrypt_parallelism = <None>
#salt_bytesize = <None>

[identity_mapping]
#driver = sql
#generator = sha256
#backward_compatible_ids = true

[jwt_tokens]
#jws_public_key_repository = /etc/keystone/jws-keys/public
#jws_private_key_repository = /etc/keystone/jws-keys/private

[ldap]
#url = ldap://localhost
#user = <None>
#password = <None>
#suffix = cn=example,cn=com
#query_scope = one
#page_size = 0
#alias_dereferencing = default
#debug_level = <None>
#chase_referrals = <None>
#user_tree_dn = <None>
#user_filter = <None>
#user_objectclass = inetOrgPerson
#user_id_attribute = cn
#user_name_attribute = sn
#user_description_attribute = description
#user_mail_attribute = mail
#user_pass_attribute = userPassword
#user_enabled_attribute = enabled
#user_enabled_invert = false
#user_enabled_mask = 0
#user_enabled_default = True
#user_attribute_ignore = default_project_id
#user_default_project_id_attribute = <None>
#user_enabled_emulation = false
#user_enabled_emulation_dn = <None>
#user_enabled_emulation_use_group_config = false
#user_additional_attribute_mapping =
#group_tree_dn = <None>
#group_filter = <None>
#group_objectclass = groupOfNames
#group_id_attribute = cn
#group_name_attribute = ou
#group_member_attribute = member
#group_members_are_ids = false
#group_desc_attribute = description
#group_attribute_ignore =
#group_additional_attribute_mapping =
#group_ad_nesting = false
#tls_cacertfile = <None>
#tls_cacertdir = <None>
#use_tls = false
#tls_req_cert = demand
#connection_timeout = -1
#use_pool = true
#pool_size = 10
#pool_retry_max = 3
#pool_retry_delay = 0.1
#pool_connection_timeout = -1
#pool_connection_lifetime = 600
#use_auth_pool = true
#auth_pool_size = 100
#auth_pool_connection_lifetime = 60

[memcache]
#dead_retry = 300
#socket_timeout = 3
#pool_maxsize = 10
#pool_unused_timeout = 60
#pool_connection_get_timeout = 10

[oauth1]
#driver = sql
#request_token_duration = 28800
#access_token_duration = 86400

[oidc]
remote_id_attribute = HTTP_OIDC_ISS

[openid]
remote_id_attribute = HTTP_OIDC_ISS

[oslo_messaging_amqp]
#container_name = <None>
#idle_timeout = 0
#trace = false
#ssl = false
#ssl_ca_file =
#ssl_cert_file =
#ssl_key_file =
#ssl_key_password = <None>
#ssl_verify_vhost = false
#sasl_mechanisms =
#sasl_config_dir =
#sasl_config_name =
#sasl_default_realm =
#connection_retry_interval = 1
#connection_retry_backoff = 2
#connection_retry_interval_max = 30
#link_retry_delay = 10
#default_reply_retry = 0
#default_reply_timeout = 30
#default_send_timeout = 30
#default_notify_timeout = 30
#default_sender_link_timeout = 600
#addressing_mode = dynamic
#pseudo_vhost = true
#server_request_prefix = exclusive
#broadcast_prefix = broadcast
#group_request_prefix = unicast
#rpc_address_prefix = openstack.org/om/rpc
#notify_address_prefix = openstack.org/om/notify
#multicast_address = multicast
#unicast_address = unicast
#anycast_address = anycast
#default_notification_exchange = <None>
#default_rpc_exchange = <None>
#reply_link_credit = 200
#rpc_server_credit = 100
#notify_server_credit = 100
#pre_settled = rpc-cast
#pre_settled = rpc-reply

[oslo_messaging_kafka]
#kafka_max_fetch_bytes = 1048576
#kafka_consumer_timeout = 1.0
#pool_size = 10
#conn_pool_min_size = 2
#conn_pool_ttl = 1200
#consumer_group = oslo_messaging_consumer
#producer_batch_timeout = 0.0
#producer_batch_size = 16384
#enable_auto_commit = false
#max_poll_records = 500
#security_protocol = PLAINTEXT
#sasl_mechanism = PLAIN
#ssl_cafile =

[oslo_messaging_notifications]
#driver =
#transport_url = <None>
#topics = notifications
#retry = -1

[oslo_messaging_rabbit]
amqp_durable_queues = true
#amqp_auto_delete = false
#ssl = false
#ssl_version =
#ssl_key_file =
#ssl_cert_file =
#ssl_ca_file =
#kombu_reconnect_delay = 1.0
#kombu_compression = <None>
#kombu_missing_consumer_retry_timeout = 60
#kombu_failover_strategy = round-robin
#rabbit_login_method = AMQPLAIN

rabbit_retry_interval = 1
rabbit_retry_backoff = 2
rabbit_interval_max = 10
rabbit_durable_queues=true
rabbit_ha_queues = true
rabbit_transient_queues_ttl = 60
#rabbit_qos_prefetch_count = 0
#heartbeat_timeout_threshold = 60
#heartbeat_rate = 2

[oslo_middleware]
#max_request_body_size = 114688
#secure_proxy_ssl_header = X-Forwarded-Proto
#enable_proxy_headers_parsing = false

[oslo_policy]
enforce_scope = {{ oslo_enforce_scope }}
#policy_file = policy.json
#policy_default_rule = default
#policy_dirs = policy.d
#remote_content_type = application/x-www-form-urlencoded
#remote_ssl_verify_server_crt = false
#remote_ssl_ca_crt_file = <None>
#remote_ssl_client_crt_file = <None>
#remote_ssl_client_key_file = <None>

[policy]
#driver = sql
#list_limit = <None>

[profiler]
#enabled = false
#trace_sqlalchemy = false
#hmac_keys = SECRET_KEY
#connection_string = messaging://
#es_doc_type = notification
#es_scroll_time = 2m
#es_scroll_size = 10000
#socket_timeout = 0.1
#sentinel_service_name = mymaster
#filter_error_trace = false

[receipt]
#expiration = 300
#provider = fernet
#caching = true
#cache_time = 300
#cache_on_issue = true
[resource]
#driver = sql
#caching = true
#cache_time = <None>
#list_limit = <None>
#admin_project_domain_name = <None>
#admin_project_name = <None>
#project_name_url_safe = off
#domain_name_url_safe = off

[revoke]
#driver = sql
#expiration_buffer = 1800
#caching = true
#cache_time = 3600

[role]
#driver = <None>
#caching = true
#cache_time = <None>
#list_limit = <None>

[saml]
#assertion_expiration_time = 3600
#xmlsec1_binary = xmlsec1
#certfile = /etc/keystone/ssl/certs/signing_cert.pem
#keyfile = /etc/keystone/ssl/private/signing_key.pem
#idp_entity_id = <None>
#idp_sso_endpoint = <None>
#idp_lang = en
#idp_organization_name = SAML Identity Provider
#idp_organization_display_name = OpenStack SAML Identity Provider
#idp_organization_url = https://example.com/
#idp_contact_company = Example, Inc.
#idp_contact_name = SAML Identity Provider Support
#idp_contact_surname = Support
#idp_contact_email = support@example.com
#idp_contact_telephone = +1 800 555 0100
#idp_contact_type = other
#idp_metadata_path = /etc/keystone/saml2_idp_metadata.xml
#relay_state_prefix = ss:mem:

[security_compliance]
#disable_user_account_days_inactive = <None>
#lockout_failure_attempts = <None>
#lockout_duration = 1800
#password_expires_days = <None>
#unique_last_password_count = 0
#minimum_password_age = 0
#password_regex = <None>
#password_regex_description = <None>
#change_password_upon_first_use = false

[shadow_users]
#driver = sql

[signing]
#certfile = /etc/keystone/ssl/certs/signing_cert.pem
#keyfile = /etc/keystone/ssl/private/signing_key.pem
#ca_certs = /etc/keystone/ssl/certs/ca.pem
#ca_key = /etc/keystone/ssl/private/cakey.pem
#key_size = 2048
#valid_days = 3650
#cert_subject = /C=US/ST=Unset/L=Unset/O=Unset/CN=www.example.com

[token]
expiration = 3600
provider = fernet
#caching = true
#cache_time = <None>
#revoke_by_id = true
#allow_rescope_scoped_token = true
#infer_roles = true
#cache_on_issue = true
#allow_expired_window = 172800

[tokenless_auth]
#trusted_issuer =
#protocol = x509
#issuer_attribute = SSL_CLIENT_I_DN

[trust]
#allow_redelegation = false
#max_redelegation_count = 3
#driver = sql

[unified_limit]
#driver = sql
#caching = true
#cache_time = <None>
#list_limit = <None>
#enforcement_model = flat

[wsgi]
#debug_middleware = false
